# Copyright © 2016 CNRS,
# Copyright © 2016 Université de Nantes.
# Author: Florian Blachère
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Get the include directory from the environment variable (a:b:c)
# and convert it to -Ia -Ib -Ic
ifneq ($(INCLUDE),)
	INCDIR+=-I$(subst :,  -I,$(INCLUDE))
endif

ifeq ($(SILO),1)
	LDFLAGS+=-lstdc++ -lsiloh5
	INCDIR+=-I/usr/include
	PREPROC+=-D_LIB_SILO_
endif # SILO

ifeq ($(HDF5),1)
	LDFLAGS+=-lhdf5_fortran
	INCDIR+=-I/usr/include
	PREPROC+=-D_LIB_HDF5_
endif # HDF5

ifeq ($(NC),1)
	LDFLAGS+=-lnetcdff
	INCDIR+=-I/usr/include
	PREPROC+=-D_LIB_NC_
endif # NC

ifeq ($(GLPK),1)
	LDFLAGS+=-lglpk
	PREPROC+=-D_LIB_GLPK_
	VERSION:=$(VERSION)_glpk
endif # GLPK

ifeq ($(NLOPT),1)
	LDFLAGS+=-lnlopt
	INCDIR+=-I/usr/include
	PREPROC+=-D_LIB_NLOPT_
	VERSION:=$(VERSION)_nlopt
endif # NLOPT

ifeq ($(IPOPT),1)
	LDFLAGS+=-lipopt -lcoinmetis -lcoinmumps -lcoinhsl -ldl
	# BLAS and LAPACK should be already linked elsewhere
	#LDFLASS+=-llapack -lblas
	PREPROC+=-D_LIB_IPOPT_
	VERSION:=$(VERSION)_ipopt
endif # IPOPT

ifeq ($(BLAS),1)
	LDFLAGS+=-llapack -lblas
	PREPROC+=-D_LIB_LAPACK_='"BLAS"' -D_LIB_LAPACK_BLAS_
endif # BLAS

ifeq ($(ATLAS),1)
	LDFLAGS+=-llapack -lblas
	PREPROC+=-D_LIB_LAPACK_='"ATLAS"' -D_LIB_LAPACK_ATLAS_
endif # ATLAS

ifeq ($(OPENBLAS),1)
	LDFLAGS+=-lopenblas
	PREPROC+=-D_LIB_LAPACK_='"OPENBLAS"' -D_LIB_LAPACK_OPENBLAS_
endif # OPENBLAS

ifeq ($(MKL),1)
	PREPROC+=-D_LIB_LAPACK_='"MKL"' -D_LIB_LAPACK_MKL_

ifeq ($(FC_FAMILY), intel)
ifneq ($(OMP),1)
			LDFLAGS+=-lmkl_intel_lp64 -lmkl_core -lmkl_sequential -lpthread -lm
else
			LDFLAGS+=-lmkl_intel_lp64 -lmkl_core -lmkl_intel_thread -lpthread -lm
endif # OMP
endif # INTEL

ifeq ($(FC_FAMILY), gnu)
ifneq ($(OMP),1)
			LDFLAGS+=-lmkl_gf_lp64 -lmkl_core -lmkl_sequential -lpthread -lm
else
			LDFLAGS+=-lmkl_gf_lp64 -lmkl_core -lmkl_gnu_thread -ldl -lpthread -lm
endif # OMP
endif # GNU

endif # MKL
