!> Main file
!>
!> @author Florian Blachère
!>
!> @copyright © 2016 CNRS,
!> @copyright © 2016 Université de Nantes.
!> @copyright This program is free software: you can redistribute it and/or modify
!> it under the terms of the GNU General Public License as published by
!> the Free Software Foundation, either version 3 of the License, or
!> (at your option) any later version.
!>
!> @copyright This program is distributed in the hope that it will be useful,
!> but WITHOUT ANY WARRANTY; without even the implied warranty of
!> MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!> GNU General Public License for more details.
!>
!> @copyright You should have received a copy of the GNU General Public License
!> along with this program.  If not, see <http://www.gnu.org/licenses/>.
program prog_AdmAP2D

  use mod_tools_sys, only: Initialize
  use mod_scheme, only: scheme
  use mod_numerics, only: MaxLen

  use mod_tools_time, only: GetTime, Print_Time_End
  use mod_tools_time, only: TimeCounters

  implicit none

  character(len=MaxLen) :: mesh_file, info

  call CPU_TIME(TimeCounters%CPU(1))
  TimeCounters%WallTime(1) = GetTime()

#if defined(_OMPP_)
#else
  call Initialize(' ', ' ', ' ', ' ', ' ', ' ', mesh_file, info)
#endif /* _OMPP_ */

  call scheme(mesh_file, info)

  TimeCounters%WallTime(2) = GetTime() - TimeCounters%WallTime(1)
  call CPU_TIME(TimeCounters%CPU(2))

  call Print_Time_End()

end program prog_AdmAP2D
